// DeviceProfile.h : Declaration of the CDeviceProfile

#pragma once
#include "resource.h"       // main symbols

#include "NWriterObjects.h"


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif



// CDeviceProfile

class ATL_NO_VTABLE CDeviceProfile :
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CDeviceProfile, &CLSID_DeviceProfile>,
	public IDispatchImpl<IDeviceProfile, &IID_IDeviceProfile, &LIBID_NWriterObjectsLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CDeviceProfile()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DEVICEPROFILE)


BEGIN_COM_MAP(CDeviceProfile)
	COM_INTERFACE_ENTRY(IDeviceProfile)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()



	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

	CComBSTR	m_Filename;
	CComBSTR	m_SectionName;
public:

	STDMETHOD(get_Item)(BSTR Name, BSTR* pVal);
	STDMETHOD(put_Filename)(BSTR newVal);
	STDMETHOD(put_SectionName)(BSTR newVal);
	STDMETHOD(Int)(BSTR Index, LONG* pValue);
	STDMETHOD(get_ArrayVal)(BSTR Key, AVTVAL nType, IProfileValues** pVal);
	STDMETHOD(get_BaseDir)(BSTR* pVal);
	STDMETHOD(put_BaseDir)(BSTR newVal);
	CComBSTR m_basedir;
	void FPGetPrivateProfileString(LPCWSTR section, LPCWSTR Name, LPCWSTR defstr, LPWSTR buf, DWORD count, LPCWSTR filename);
};

OBJECT_ENTRY_AUTO(__uuidof(DeviceProfile), CDeviceProfile)
